/* -*- buffer-read-only: t -*- vi: set ro:
#line 426
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 426
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_string.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

void
#line 19
bi_toupper(eval_environ_t env)
#line 19

#line 19 "bi_string.m4"
{
#line 19
	
#line 19
char * string = (char *) get_string_arg(env, 0);
#line 19
        
#line 19
        adjust_stack(env, 1);
#line 19

#line 19
	if (prog_trace_option & BUILTIN_MASK_string)
#line 19
		prog_trace(env, "toupper %s",string);;
#line 19

{
	size_t off;
	char *s = strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(string) + 1)), string);
	char *p;
	for (p = s; *p; p++)
		*p = toupper(*p);
	do {
#line 26
push(env, (STKVAL) (off));
#line 26
return;
#line 26
} while (0);
}
}

void
#line 30
bi_tolower(eval_environ_t env)
#line 30

#line 30 "bi_string.m4"
{
#line 30
	
#line 30
char * string = (char *) get_string_arg(env, 0);
#line 30
        
#line 30
        adjust_stack(env, 1);
#line 30

#line 30
	if (prog_trace_option & BUILTIN_MASK_string)
#line 30
		prog_trace(env, "tolower %s",string);;
#line 30

{
	size_t off;
	char *s = strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(string) + 1)), string);
	char *p;
	for (p = s; *p; p++)
		*p = tolower(*p);
	do {
#line 37
push(env, (STKVAL) (off));
#line 37
return;
#line 37
} while (0);
}
}

void
#line 41
bi_length(eval_environ_t env)
#line 41

#line 41 "bi_string.m4"
{
#line 41
	
#line 41
char * string = (char *) get_string_arg(env, 0);
#line 41
        
#line 41
        adjust_stack(env, 1);
#line 41

#line 41
	if (prog_trace_option & BUILTIN_MASK_string)
#line 41
		prog_trace(env, "length %s",string);;
#line 41

{
	do {
#line 43
push(env, (STKVAL) (strlen(string)));
#line 43
return;
#line 43
} while (0);
}
}

void
#line 47
bi_substring(eval_environ_t env)
#line 47

#line 47 "bi_string.m4"
{
#line 47
	
#line 47
char * string = (char *) get_string_arg(env, 2);
#line 47
        long  start = (long ) get_numeric_arg(env, 1);
#line 47
        long  end = (long ) get_numeric_arg(env, 0);
#line 47
        
#line 47
        adjust_stack(env, 3);
#line 47

#line 47
	if (prog_trace_option & BUILTIN_MASK_string)
#line 47
		prog_trace(env, "substring %s %lu %lu",string, start, end);;
#line 47

{
	size_t off;
	long len = strlen(string);
	char *s;
	
	if (end < 0)
		end = len - 1;
	if (end < start) {
		long t = end;
		end = start;
		start = t;
	}

		if (!(start < len && end < len))
			env_throw(env, mf_range,                                             "substring: " "argument out of range");
#line 62
;
#line 62
;
	
	len = end - start + 1;
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, string + start, len);
	s[len] = 0;
	
	do {
#line 69
push(env, (STKVAL) (off));
#line 69
return;
#line 69
} while (0);
}
}

void
#line 73
bi_substr(eval_environ_t env)
#line 73

#line 73 "bi_string.m4"
{
#line 73
	
#line 73
char * string = (char *) get_string_arg(env, 2);
#line 73
        long  start = (long ) get_numeric_arg(env, 1);
#line 73
        long  nbytes = (long ) get_numeric_arg(env, 0);
#line 73
        
#line 73
        adjust_stack(env, 3);
#line 73

#line 73
	if (prog_trace_option & BUILTIN_MASK_string)
#line 73
		prog_trace(env, "substr %s %lu %lu",string, start, nbytes);;
#line 73

{
	size_t off;
	long len = strlen(string);
	char *s;
	
		if (!(start >= 0))
			env_throw(env, mf_range,                                             "substr: " "argument out of range: start=%ld",start);
#line 80
;
#line 80
;
	if (nbytes == 0)
		nbytes = len - start;
		if (!(nbytes >= 0))
#line 83
			env_throw(env, mf_range,                                             "substr: " "argument out of range: start=%ld,len=%ld",start,len);
#line 83
;
#line 83
;
	
	s = (char*) env_data_ref(env, (off = heap_reserve(env, nbytes + 1)));
	memcpy(s, string + start, nbytes);
	s[nbytes] = 0;
	
	do {
#line 89
push(env, (STKVAL) (off));
#line 89
return;
#line 89
} while (0);
}
}

void
#line 93
bi_index(eval_environ_t env)
#line 93

#line 93 "bi_string.m4"
{
#line 93
	
#line 93
char * str = (char *) get_string_arg(env, 1);
#line 93
        char * sub = (char *) get_string_arg(env, 0);
#line 93
        
#line 93
        adjust_stack(env, 2);
#line 93

#line 93
	if (prog_trace_option & BUILTIN_MASK_string)
#line 93
		prog_trace(env, "index %s %s",str, sub);;
#line 93

{
	char *p = strstr(str, sub);
	do {
#line 96
push(env, (STKVAL) (p ? p - str : -1));
#line 96
return;
#line 96
} while (0);
}
}

void
#line 100
bi_rindex(eval_environ_t env)
#line 100

#line 100 "bi_string.m4"
{
#line 100
	
#line 100
char * str = (char *) get_string_arg(env, 1);
#line 100
        char * sub = (char *) get_string_arg(env, 0);
#line 100
        
#line 100
        adjust_stack(env, 2);
#line 100

#line 100
	if (prog_trace_option & BUILTIN_MASK_string)
#line 100
		prog_trace(env, "rindex %s %s",str, sub);;
#line 100

{
	int slen, xlen, rc;
	char *p, *s, *x;
	char *temp;

	slen = strlen(str);
	xlen = strlen(sub);
	temp = heap_tempspace(env, xlen + slen + 2);
	s = temp;
	x = s + slen + 1;
	
	/* Reverse str */                     
#define REV(v,s,l)                                         \
	l = strlen(s);                                     \
	v[l] = 0;                                          \
	for (p = v + l - 1; p >= v; p--, s++)              \
		*p = *s;

	REV(s,str,slen);
	REV(x,sub,xlen);

	p = strstr(s, x);
	if (p)
		rc = slen - (p - s + xlen);
	else
		rc = -1;
	
	do {
#line 128
push(env, (STKVAL) (rc));
#line 128
return;
#line 128
} while (0);
}
}

void
#line 132
bi_revstr(eval_environ_t env)
#line 132

#line 132 "bi_string.m4"
{
#line 132
	
#line 132
char * str = (char *) get_string_arg(env, 0);
#line 132
        
#line 132
        adjust_stack(env, 1);
#line 132

#line 132
	if (prog_trace_option & BUILTIN_MASK_string)
#line 132
		prog_trace(env, "revstr %s",str);;
#line 132

{
	int len = strlen(str);
	char *p;
	size_t off;
	char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));

	s[len] = 0;
	for (p = s + len - 1; p >= s; p--, str++)
		*p = *str;
	do {
#line 142
push(env, (STKVAL) (off));
#line 142
return;
#line 142
} while (0);
}
}

void
#line 146
bi_message_header_decode(eval_environ_t env)
#line 146

#line 146 "bi_string.m4"
{
#line 146
	
#line 146
char * text = (char *) get_string_arg(env, 1);
#line 146
        char * charset = (char *) get_string_arg(env, 0);
#line 146
        
#line 146
        adjust_stack(env, 2);
#line 146

#line 146
	if (prog_trace_option & BUILTIN_MASK_string)
#line 146
		prog_trace(env, "message_header_decode %s %s",text, charset);;
#line 146

{
	char *p;
	int rc = mu_rfc2047_decode (((charset && charset[0]) ? charset : "utf-8"), text, &p);
		if (!(rc == 0))
#line 153
			env_throw(env, mf_failure,                                             "message_header_decode: " "error decoding string: %s",mu_strerror(rc));
#line 153
;
#line 153
;
	pushs(env, p);
	free(p);
}
}

#line 160
void
#line 160
bi_message_header_encode(eval_environ_t env)
#line 160

#line 160 "bi_string.m4"
{
#line 160
	
#line 160
char * text = (char *) get_string_arg(env, 2);
#line 160
        char * encoding = (char *) get_string_arg(env, 1);
#line 160
        char * charset = (char *) get_string_arg(env, 0);
#line 160
        
#line 160
        adjust_stack(env, 3);
#line 160

#line 160
	if (prog_trace_option & BUILTIN_MASK_string)
#line 160
		prog_trace(env, "message_header_encode %s %s %s",text, encoding, charset);;
#line 160

{
	char *p;
	int rc = mu_rfc2047_encode (((charset && charset[0]) ? charset : "utf-8"),
				    ((encoding && encoding[0]) ? encoding : "quoted-printable"),
				    text, &p);
		if (!(rc == 0))
#line 169
			env_throw(env, mf_failure,                                             "message_header_encode: " "error encoding string: %s",mu_strerror(rc));
#line 169
;
#line 169
;
	pushs(env, p);
	free(p);
}
}

void
#line 175
bi_unfold(eval_environ_t env)
#line 175

#line 175 "bi_string.m4"
{
#line 175
	
#line 175
char * text = (char *) get_string_arg(env, 0);
#line 175
        
#line 175
        adjust_stack(env, 1);
#line 175

#line 175
	if (prog_trace_option & BUILTIN_MASK_string)
#line 175
		prog_trace(env, "unfold %s",text);;
#line 175

{
	size_t off;
	char *s = strcpy((char*)env_data_ref(env, off = heap_reserve(env, strlen(text) + 1)), text);
	mu_string_unfold(s, NULL);
	do {
#line 180
push(env, (STKVAL) (off));
#line 180
return;
#line 180
} while (0);
}
}


#line 184
void
#line 184
string_init_builtin()
#line 184
{
#line 184
	#line 19 "bi_string.m4"
va_builtin_install_ex("toupper", bi_toupper, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 30 "bi_string.m4"
va_builtin_install_ex("tolower", bi_tolower, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 41 "bi_string.m4"
va_builtin_install_ex("length", bi_length, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 47 "bi_string.m4"
va_builtin_install_ex("substring", bi_substring, 0, 0, dtype_string,  3, 0,  dtype_string, dtype_number, dtype_number);
#line 73 "bi_string.m4"
va_builtin_install_ex("substr", bi_substr, 0, 0, dtype_string,  3, 1,  dtype_string, dtype_number, dtype_number);
#line 93 "bi_string.m4"
va_builtin_install_ex("index", bi_index, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 100 "bi_string.m4"
va_builtin_install_ex("rindex", bi_rindex, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_string);
#line 132 "bi_string.m4"
va_builtin_install_ex("revstr", bi_revstr, 0, 0, dtype_string,  1, 0,  dtype_string);
#line 146 "bi_string.m4"
va_builtin_install_ex("message_header_decode", bi_message_header_decode, 0, 0, dtype_string,  2, 1,  dtype_string, dtype_string);
#line 160 "bi_string.m4"
va_builtin_install_ex("message_header_encode", bi_message_header_encode, 0, 0, dtype_string,  3, 2,  dtype_string, dtype_string, dtype_string);
#line 175 "bi_string.m4"
va_builtin_install_ex("unfold", bi_unfold, 0, 0, dtype_string,  1, 0,  dtype_string);

#line 184 "bi_string.m4"
		
#line 184
}
#line 0

#line 0

